# This file was auto-generated by Fern from our API Definition.

import enum
import typing

T_Result = typing.TypeVar("T_Result")


class StorageTypeEnum(str, enum.Enum):
    """
    The data source of the dataset

    s3 - AWS S3 bucket
    local - A local path (unavailable via the SDK)
    """

    LOCAL = "local"
    S_3 = "s3"
    GS = "gs"

    def visit(
        self,
        local: typing.Callable[[], T_Result],
        s_3: typing.Callable[[], T_Result],
        gs: typing.Callable[[], T_Result],
    ) -> T_Result:
        if self is StorageTypeEnum.LOCAL:
            return local()
        if self is StorageTypeEnum.S_3:
            return s_3()
        if self is StorageTypeEnum.GS:
            return gs()
