# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

import pydantic

from ..core.datetime_utils import serialize_datetime


class TestConfigurationResponse(pydantic.BaseModel):
    """
    A response for a test of the configuration of an IAM role for a given data path
    """

    credentials_id: str = pydantic.Field(alias="credentialsId", description="The id of the credentials")
    data_path: str = pydantic.Field(alias="dataPath", description="The absolute path to the data")
    success: bool = pydantic.Field(
        description="True if data can be read at the specified data path using the provided credentials"
    )
    detail: typing.Optional[str] = pydantic.Field(description="An explanation of the test failure")

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().dict(**kwargs_with_defaults)

    class Config:
        frozen = True
        smart_union = True
        allow_population_by_field_name = True
        json_encoders = {dt.datetime: serialize_datetime}
