# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

import pydantic

from ..core.datetime_utils import serialize_datetime


class VideoAsset(pydantic.BaseModel):
    """
    Metadata about a video
    """

    url: str = pydantic.Field(description="The URL of the asset")
    id: str = pydantic.Field(description="The unique video id")
    start_time_ms: int = pydantic.Field(
        alias="startTimeMs",
        description="The start time in milliseconds from the beginning of the video. Deprecation warning - use 'shot.start_time_ms'.",
    )
    end_time_ms: int = pydantic.Field(
        alias="endTimeMs",
        description="The end time in milliseconds from the beginning of the video. Deprecation warning - use 'shot.end_time_ms'.",
    )

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().dict(**kwargs_with_defaults)

    class Config:
        frozen = True
        smart_union = True
        allow_population_by_field_name = True
        json_encoders = {dt.datetime: serialize_datetime}
